#create file on filesystem in $ZOPE/Extensions called ftpme.py
import ftplib, sys
from string import split, lower, join
from StringIO import StringIO

host='localhost'
login='runyaga'
password='^%$^@5@#$S'
port=21

def ftp(file=None, obj=None, text=None, host=host, login=login, password=password, port=port, remote_directory="", remote_name="", content_type=""):
    if file is None and obj is None and text is None:
        return (1, "Both file, obj and text is None")

    _ftp = ftplib.FTP()

    try:
        _ftp.connect(host, port)
    except ftplib.all_errors:
        return (sys.exc_type, sys.exc_value)

    try:
        _ftp.login(login, password)
    except ftplib.all_errors:
        return (sys.exc_type, sys.exc_value)

    if remote_directory:
        try:
            _ftp.cwd(remote_directory)
        except:
            return (sys.exc_type, sys.exc_value)

    if text:
        try:
            ftp_text(_ftp, text, remote_name)
        except ftplib.all_errors, resp:
            return (1, resp)
    elif file:
        if not remote_name:
            return (400, "When ftp'ing filesystem files supply a remote name.")
        binary = 1 # we go all binary
        #if content_type[:4]=='text': binary=0
        ftp_file(_ftp, file, binary, remote_name)

    elif obj:
        if lower(obj.meta_type)=='file':
            binary=1
            if obj.content_type[:4]=='text': binary=0
            ftp_obj(_ftp, obj, binary, remote_name)

        if lower(obj.meta_type)=='image':
            ftp_file(_ftp, obj, 1, remote_name)

    _ftp.quit()
    return (204, "Upload succeeded")

def ftp_file(ftpCon, file, binary, remote_name):
    name = remote_name
    if binary:
        ftpCon.storbinary("STOR " + name, file, 1024)
    else:
        ftp_text(ftpCon, file, name)

def ftp_obj(ftpCon, fileObj, binary, remote_name = ""):
    if not remote_name:
        name = fileObj.getId()
    else:
        name = remote_name
    if binary:
        ftpCon.storbinary("STOR " + name, StringIO(fileObj.data), 1024)
    else:
        ftp_text(ftpCon, fileObj.data, name)

def ftp_text(ftpCon, text, remote_name = ""):
    if not remote_name:
        raise ftplib.Error, "Remote name not supplied"
    else:
	#raise "text: %s" % text
        ftpCon.storlines("STOR " + remote_name, StringIO(text))

